<?php
ob_start();
defined('BASEPATH') or die('No direct script access allowed');

class AboutController extends CI_Controller
{
	function __construct()
	{
		parent::__construct();
		
		$this->load->model('AboutModel');
		if($this->session->userdata('lock_admin_id'))
			redirect('lock','refresh');
		else if(!$this->session->userdata('admin_id'))
			redirect('login','refresh');
		else if($this->session->userdata('admin_type') != 'SUPER' && !$this->session->userdata('PER_about')) 
			redirect('admin','refresh');
	}

	public function index()
	{
		
        /* header content */
        $this->load->model("InboxOutboxModel");
        $data["inbox_content"] = $this->InboxOutboxModel->inbox_content();
	
		$this->load->model("ContactModel");
        $data["contact_content"] = $this->ContactModel->content();
    

		/* content to be display in list view */
		$data['display_content'] = $this->AboutModel->content();
		
		

		/* publish and unpublish count to display */
		$data['publish_count'] = $this->AboutModel->publish_unpublish_count(1); /*status*/
		$data['unpublish_count'] = $this->AboutModel->publish_unpublish_count(0); /*status*/
		
		$this->load->view('about', $data);
	}

	public function edit($id)
	{
		
        /* header content */
        $this->load->model("InboxOutboxModel");
        $data["inbox_content"] = $this->InboxOutboxModel->inbox_content();
	
		$this->load->model("ContactModel");
        $data["contact_content"] = $this->ContactModel->content();
    

		/* content to be display in list view */
		$data['display_content'] = $this->AboutModel->content();
		
		

		/* publish and unpublish count to display */
		$data['publish_count'] = $this->AboutModel->publish_unpublish_count(1); /*status*/
		$data['unpublish_count'] = $this->AboutModel->publish_unpublish_count(0); /*status*/

		/* edited record content */
		$data['edit_content'] = $this->AboutModel->edit($id);
		
		$this->load->view('about', $data);
	}

	
		
	public function post()
	{
		/* your insert / update code is here */
	
		
			$post_data = $this->input->post();
		
			//load upload class library with configuration
			$config =  array(
	              'upload_path'     => '../upload/about/',
	              'allowed_types'   => 'png|PNG|jpg|jpeg|JPG|JPEG|gif|GIF|bmp|BMP',
	              'overwrite'       => FALSE,
	              'max_size'        => '2048000',  // Can be set to particular file size
	            );    
			$this->load->library('upload', $config);
			// upload about_home image1
			if($this->upload->do_upload('about_home_image1'))
			{
				if(isset($post_data['about_home_image1_previous']) && !empty($post_data['about_home_image1_previous']) && file_exists('../upload/about/'.$post_data['about_image1_previous']))
					unlink('../upload/about/'.$post_data['about_home_image1_previous']);
				$upload_data = $this->upload->data();
				$post_data['about_home_image1'] = $upload_data['file_name'];
			}
			else
			{
				$post_data['about_home_image1'] = $post_data['about_home_image1_previous'];
			}

			// upload about_home image2
			if($this->upload->do_upload('about_home_image2'))
			{
				if(isset($post_data['about_home_image2_previous']) && !empty($post_data['about_home_image2_previous']) && file_exists('../upload/about/'.$post_data['about_home_image2_previous']))
					unlink('../upload/about/'.$post_data['about_home_image2_previous']);
				$upload_data = $this->upload->data();
				$post_data['about_home_image2'] = $upload_data['file_name'];
			}
			else
			{
				$post_data['about_home_image2'] = $post_data['about_home_image2_previous'];
			}
					
			// upload about_image1
			if($this->upload->do_upload('about_image1'))
			{
				if(isset($post_data['about_image1_previous']) && !empty($post_data['about_image1_previous']) && file_exists('../upload/about/'.$post_data['about_image1_previous']))
					unlink('../upload/about/'.$post_data['about_image1_previous']);
				$upload_data = $this->upload->data();
				$post_data['about_image1'] = $upload_data['file_name'];
			}
			else
			{
				$post_data['about_image1'] = $post_data['about_image1_previous'];
			}
			
			// upload about_image2
			if($this->upload->do_upload('about_image2'))
			{
				if(isset($post_data['about_image2_previous']) && !empty($post_data['about_image2_previous']) && file_exists('../upload/about/'.$post_data['about_image2_previous']))
					unlink('../upload/about/'.$post_data['about_image2_previous']);
				$upload_data = $this->upload->data();
				$post_data['about_image2'] = $upload_data['file_name'];
			}
			else
			{
				$post_data['about_image2'] = $post_data['about_image2_previous'];
			}
			//print_r($post_data);exit;
			
			$result = $this->AboutModel->post($post_data);

			if($result == 'inserted')
			{
				$this->session->set_userdata('alert_type','success');
				$this->session->set_userdata('alert_title','Inserted Successfully');
				$this->session->set_userdata('alert_message','The information has been inserted successfully.');
	    	}
			else if($result == 'updated')
			{
				$this->session->set_userdata('alert_type','success');
				$this->session->set_userdata('alert_title','Updated Successfully');
				$this->session->set_userdata('alert_message','The information has been updated successfully.');
	    	}
			else
			{
				$this->session->set_userdata('alert_type','danger');
				$this->session->set_userdata('alert_title','Error');
				$this->session->set_userdata('alert_message','There is something problem to submit your action, please try again.');
	    	}
			
			redirect('about', 'refresh'); 
	}	

	
}
?>