<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class LoginController extends CI_Controller {

	/**
	 * Index Page for this controller.
	 *
	 * Maps to the following URL
	 * 		http://example.com/index.php/welcome
	 *	- or -
	 * 		http://example.com/index.php/welcome/index
	 *	- or -
	 * Since this controller is set as the default controller in
	 * config/routes.php, it's displayed at http://example.com/
	 *
	 * So any other public methods not prefixed with an underscore will
	 * map to /index.php/welcome/<method_name>
	 * @see https://codeigniter.com/user_guide/general/urls.html
	 */

	public function __construct()
	{
		parent::__construct();
		$this->load->model('LoginModel');
		$this->load->model('InboxOutboxModel');
		$this->load->model('AdminModel');
	}

	public function index()
	{ 
		/* header content */
        $this->load->model("ContactModel");
        $data["contact_content"] = $this->ContactModel->content();

		$this->load->view('login', $data);
	}

	public function json_login()
	{ 
		$post_data = $this->input->post();

		if(!empty($post_data))
		{
			
			if(count($data = $this->LoginModel->login_content($post_data['username'], $post_data['password'])))
			{
				if($data[0]['admin_verification_status'] == 1)
				{
					$_SESSION = [];
					$this->LoginModel->update_login($post_data['username'], 0);
				
					$this->session->set_userdata('admin_id',$data[0]['tbl_admin_id']);
					$this->session->set_userdata('admin_name',$data[0]['admin_name']);
					$this->session->set_userdata('admin_email',$data[0]['admin_email']);
					$this->session->set_userdata('admin_contact',$data[0]['admin_contact']);
					$this->session->set_userdata('admin_profile',$data[0]['admin_profile']);
					$this->session->set_userdata('admin_theme_color',$data[0]['admin_theme_color']);
					$this->session->set_userdata('profile_percentage',round(count(array_filter($data[0])) / (count($data[0])-1) * 100));
					$this->session->set_userdata('admin_inbox',$this->InboxOutboxModel->inbox_content());

					/* set session of admi type */
					$this->session->set_userdata('admin_type', $data[0]['admin_type']);	
					
					/* set session of permission pages and their access */
					if($data[0]['admin_type'] != 'SUPER')
					{
						foreach($data as $data_content)
						{
							$this->session->set_userdata('PER_'.$data_content['admin_permission_name'], $data_content['admin_permission_access']);
						}
					}

					echo "login";
					/*p-notification*/
					$this->session->set_userdata('alert_type','success');
					$this->session->set_userdata('alert_title','Login Successfully');
					$this->session->set_userdata('alert_message','Logged in as '.$data[0]['admin_name'].'<br>'.$data[0]['admin_email'].', '.$data[0]['admin_contact'].'<b style="color:#a94442">\' '.($data[0]['admin_type'] == 'SUPER' ? 'SUPER Admin | Full Authority' : 'SUB Admin | Authorized').' \'</b>');
					/*p-notification*/
				}
				else
				{
					echo "verification";
				}		
			}
			else
			{ 
				if(count($data = $this->LoginModel->login_content($post_data['username'])))
				{
					echo $this->LoginModel->update_login($post_data['username'], 1);
				}
				else
					echo "fail";
			}
		}
	}

	public function randomPassword() {
	    $alphabet = '@#$abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890';
	    $pass = array(); //remember to declare $pass as an array
	    $alphaLength = strlen($alphabet) - 1; //put the length -1 in cache
	    for ($i = 0; $i < 8; $i++) {
	        $n = rand(0, $alphaLength);
	        $pass[] = $alphabet[$n];
	    }
	    return implode($pass); //turn the array into a string
	}

	public function json_forgot_password()
	{
		if(count($data = $this->LoginModel->login_content($this->input->post('forgot-username'))))
		{
			if($data[0]['admin_verification_status'] == 1)
			{
				if($this->send_admin_password($data))
				{
					echo 'sent';
				}
				else
				{
					echo 'fail';
				}
			}
			else
			{
				echo "verification";
			}	
		}
	}

	public function send_admin_password($data)
	{
		$random_password = $this->randomPassword();
		if(!empty($random_password))
		{
			$message = '';
			$message .='<p>Hello '.$data[0]['admin_name'].',</p>'."\r\n";						

			$message .='<p>The email was generated as a request from the Forgot Password retrieval based on the search criteria provided. The login information has only been sent to this email address.</p>'."\r\n";
			$message .='<p>To ensure account security, please change your password immediately through you Account profile.</p>'."\r\n";
			$message .='<p>Your Password : '.$random_password.'</p>'."\r\n";
			$message .='<p>If this information dose not allow you to access your site(s), please return to the login assistance page and enter a different login name or email address to locate other accounts.</p>'."\r\n";

			//$message .='-----'."\r\n";
			//$message .='<p>If you have any questions or trouble on please contact us at <a href="www.egranthalaya.com">www.egranthalaya.com</a><br/>'."\r\n";
			//$message .='Website : http://www.egranthalaya.com/ <br/> Contact : 1-844-358-1023 <br/> Email : info@egranthalaya.com <br/><br/> Thank You! <br/><b> E-Granthalaya Support Services</b> <br/>';
			//$message .= '<a href="'.base_url().'"><img style="width:30%" src="'.base_url().'logo_default.png" alt=""></a>';
			//$message .='<hr/><i>* The location is approximate and determined by the IP address it was coming from.</i>'."\r\nThis email can't receive replies.";
			//$message .=''."\r\n";

			$result = $this->AdminModel->send_mail('works@oystertechnology.in',$data[0]['admin_email'],'','','E-Granthalaya','e-granthalaya | password',$message);
			if($result)
			{
				$this->LoginModel->reset_password($data[0]['tbl_admin_id'], $random_password);
				return true;
			}
			else
				return false;
		}
	}

	public function verify_admin($admin_id, $admin_key)
	{
		if(isset($admin_id) && !empty($admin_id) && isset($admin_key) && !empty($admin_key))
		{
			if($data = $this->LoginModel->verify_admin($admin_id, $admin_key))
			{ //var_dump($admin_id, $admin_key); die;
				$new_admin_key = $this->randomPassword();
				$this->LoginModel->set_verification_key($admin_id, $new_admin_key, 1);
				if($this->send_admin_password($data))
				{
					$data['error'] = 'Verify Successfully';
					$data['message'] = '<br><br>Your admin account is successfully verified ! Please login to access your account ! <br><br> The authenticated password has been sent on your registered mail, please confirm the inbox.';
					$this->load->view('verify', $data);
				}
				else
				{
					$data['error'] = 'Verification Mail Sent';
					$data['message'] = '<br><br>Your admin account is successfully verified ! Please login to access your account ! <br><br> Something problem to send authenticated password via mail, please try later !';
					$this->load->view('verify', $data);
				}
				
			}
			else
			{
				$data['error'] = 'Verify Link Expire ?';
				$data['message'] = '<br><br>Your admin account verification failure ! Please try again or contact with support team ! <br><br> The authenticated password will be send on your registered mail after successful verification.';
				$this->load->view('verify',$data);
			}
		}
	}

	public function json_send_verification()
	{ 
		if(count($data = $this->LoginModel->login_content($this->input->post('username')/*, $this->input->post('password')*/)))
		{
			$random_verification_key = $this->randomPassword();
			if(!empty($random_verification_key))
			{
				$message = '';
				$message .='<p>Hello '.$data[0]['admin_name'].',</p>'."\r\n";						

				$message .='<p>The email was generated as a request from the Verify Account retrieval based on the search criteria provided. The login information has only been sent to this email address.</p>'."\r\n";
	    		$message .='<p>To ensure account security, please change your password immediately through you Account profile.</p>'."\r\n";
	    		$message .='<p>Your account has been locked or not verified. Your account appears to have exhibited automated behaviour that violats the rules. To unlock your account, please click the below verification link and confirm that you are valid account owner.</p>'."\r\n";
				$message .='<p><a href="'.base_url().'login/verify-admin/'.$data[0]['tbl_admin_id'].'/'.$random_verification_key.'">verify your account</a></p>'."\r\n";
				$message .='<p>If this information dose not allow you to access your site(s), please return to the login assistance page and enter a different login name or email address to locate other accounts.</p>'."\r\n";

				
				//$message .='-----'."\r\n";
				//$message .='<p>If you have any questions or trouble on please contact us at <a href="www.egranthalaya.com">www.egranthalaya.com</a><br/>'."\r\n";
				//$message .='Website : http://www.egranthalaya.com/ <br/> Contact : 1-844-358-1023 <br/> Email : info@egranthalaya.com <br/><br/> Thank You! <br/><b> E-Granthalaya Support Services</b> <br/>';
				//$message .= '<a href="'.base_url().'"><img style="width:30%" src="'.base_url().'logo_default.png" alt=""></a>';
				//$message .='<hr/><i>* The location is approximate and determined by the IP address it was coming from.</i>'."\r\nThis email can't receive replies.";
				//$message .=''."\r\n";
			
				//$result = $this->AdminModel->send_mail('works@oystertechnology.in',$data[0]['admin_email'],'','','E-Granthalaya','e-granthalaya | account verification',$message);
				//$result = $this->AdminModel->send_mail('works@oystertechnology.in',$data[0]['admin_email'],'','','E-Granthalaya | Admin','admin | account verification',$message);
				//echo $this->email->print_debugger();
				if($result)
				{
					$this->LoginModel->set_verification_key($data[0]['tbl_admin_id'], $random_verification_key, 0);
					echo 'sent';
				}
				else
					echo 'fail';
			}
		}
	}

	public function logout()
	{
		$this->session->sess_destroy();
		redirect('login','refresh');
	}
}
?>