<?php
ob_start();
defined('BASEPATH') or exit('No direct script access allowed');

class ProfileController extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		$this->load->model('ProfileModel');
		if(!$this->session->userdata('admin_id'))
			if(!$this->session->userdata('lock_admin_id'))
				redirect('login','refresh');
			else
				redirect('lockcreen','refresh');
	}

	public function index()
	{
		$this->load->model("ContactModel");
        $data["contact_content"] = $this->ContactModel->content();
	    $data['profile_content'] = $this->ProfileModel->profile_content();
		$profile_data = $data['profile_content'][0];
		$data['profile_percentage'] = round(count(array_filter($profile_data)) / (count($profile_data)-1) * 100);
		$this->session->set_userdata('profile_percentage',$data['profile_percentage']);
		//var_dump($this->session->userdata('admin_inbox'));

		$this->load->view('profile', $data);
	}
	
	public function post()
	{ 
		$post_data = $this->input->post();
		if(isset($post_data) && !empty($post_data))
		{
			$config =  array(
				'upload_path'     => "../upload/profile-picture",
				'allowed_types'   => "gif|jpg|png|jpeg|pdf",
				'overwrite'       => TRUE,
				'max_size'        => "2048000",  // Can be set to particular file size
				//'max_height'      => "768",
				//'max_width'       => "1024"  
				);    

			if(empty($post_data['admin_password']))
				$post_data['admin_password'] = $post_data['admin_password_previous'];
			$this->load->library('upload', $config);
			if($this->upload->do_upload('admin_profile'))
			{
				$upload_data =$this->upload->data();
				$post_data['admin_profile'] = $upload_data['file_name'];
				$this->session->set_userdata('admin_profile', $post_data['admin_profile']);
			}
			else
			{
				$post_data['admin_profile'] = $post_data['admin_profile_previous'];
			}
			$result = $this->ProfileModel->post($post_data);
			if($result)
			{
				$this->session->set_userdata('admin_name', $post_data['admin_name']);
				$this->session->set_userdata('admin_email', $post_data['admin_email']);
				$this->session->set_userdata('admin_contact', $post_data['admin_contact']);
				
				/*p-notification*/
				$this->session->set_userdata('alert_title','Profile Updated Successfully');
				$this->session->set_userdata('alert_message','Your admin account has beed updated successfully.');
				/*p-notification*/
			}
			redirect('profile','refresh');
		}
		else
		{
			redirect('profile','refresh');	
		}
	}
}
?>