<?php
ob_start();
defined('BASEPATH') or exit('No direct script access allowed');

class RegisterController extends CI_Controller
{
	public function __construct()
	{
		parent::__construct();
		$this->load->model('RegisterModel');
		$this->load->model('AdminModel');
		if($this->session->userdata('lock_admin_id'))
			redirect('lock','refresh');
		else if(!$this->session->userdata('admin_id'))
			redirect('login','refresh');
		else if($this->session->userdata('admin_type') != 'SUPER') 
			redirect('admin','refresh');
	}

	public function index()
	{
		/* header content */
        $this->load->model("ContactModel");
        $data["contact_content"] = $this->ContactModel->content();
	    $data['profile_content'] = $this->RegisterModel->profile_content($this->session->userdata('admin_id'));
	    $profile_data = $data['profile_content'][0];
		$data['profile_percentage'] = round(count(array_filter($profile_data)) / (count($profile_data)-1) * 100);
		$this->session->set_userdata('profile_percentage',$data['profile_percentage']);
		$data['admin_content'] = $this->RegisterModel->admin_content();
	    
	    $this->load->view('register', $data);
	}
    
    public function json_validate_email_or_contact()
    {
    	//echo 'dd'; die;
    	$tbl_admin_id = $this->input->post('tbl_admin_id');
    	$admin_email = $this->input->post('admin_email');
    	$admin_contact = $this->input->post('admin_contact');

    	if(!empty($admin_email))
    	{
    		$result = $this->RegisterModel->json_validate_email($tbl_admin_id, $admin_email);
    		if(!empty($result))
    		{
    			echo json_encode('Email is already registered !');
    		}
    		else
    		{
    			echo json_encode(true);
    		}
    	}
    	else if(!empty($admin_contact))
    	{	
    		$result = $this->RegisterModel->json_validate_contact($tbl_admin_id, $admin_contact);
    		if(!empty($result))
    		{
    			echo json_encode('Contact is already registered !');
    		}
    		else
    		{
    			echo json_encode(true);
    		}
    	}
    }

    public function post()
	{ 
		$post_data = $this->input->post();
		//var_dump($post_data); die;
		if(isset($post_data) && !empty($post_data))
		{
			$post_data['admin_key'] = $this->randomPassword();
			//$admin_id = ((int)$this->RegisterModel->last_record())+1;
			$tbl_admin_id = $this->input->post('tbl_admin_id');
				
			//$data['edit_admin_info'][0] = $post_data;
			//$data['admin_content'] = $this->RegisterModel->admin_content();
			//$data['profile_content'] = $this->RegisterModel->profile_content(($this->session->userdata('admin_id') ? $this->session->userdata('admin_id') : $tbl_admin_id));
			
			if($this->send_welcome($post_data['admin_email'], $post_data['admin_name']))
			{
				$config =  array(
					'upload_path'     => "../upload/profile-picture",
					'allowed_types'   => "gif|jpg|png|jpeg|pdf",
					'overwrite'       => TRUE,
					//'max_size'        => "2048000",  // Can be set to particular file size
					//'max_height'      => "768",
					//'max_width'       => "1024"  
					);    
				$this->load->library('upload', $config);
				if($this->upload->do_upload('admin_profile'))
				{
					$upload_data =$this->upload->data();
					$post_data['admin_profile'] = $upload_data['file_name'];
				}
				else
				{
					$post_data['admin_profile'] = $post_data['admin_profile_previous'];
				}
				
				$new_admin_id = $this->RegisterModel->post($post_data);
				$data['edit_admin_info'] = $this->RegisterModel->edit_admin_info($new_admin_id);
				//var_dump($data['edit_admin_info']); die;
				
				if(empty($tbl_admin_id))
				{
					if($this->send_verification($post_data['admin_email'], $post_data['admin_name'], $new_admin_id, $post_data['admin_key']))
					{
						//$data['error'] = 'Verification Mail Sent';
						//$data['message'] = '<br><br>Your admin account has beed created successfully and the verification mail has been sent on your registered mail. <br>
						//Your account appears to have exhibited automated behaviour that violats the rules. <br><br>To unlock your account, please click the link sent on verification mail and confirm that you are valid account owner.';
						/*p-notification*/
						$this->session->set_userdata('alert_title','Verification Mail Sent');
						$this->session->set_userdata('alert_message','Your admin account has beed created successfully and the verification mail has been sent on your registered mail. <br>
						Your account appears to have exhibited automated behaviour that violats the rules. <br><br>To unlock your account, please click the link sent on verification mail and confirm that you are valid account owner.');
						/*p-notification*/
						
						redirect('register/verify','refresh');
					}
					else
					{
						//$post_data['error'] = 'verification-mail-fail';
						//$post_data['message'] = 'Your account has been created successfully... Their is something problem to send verification link via mail, please contact to support team !';
						/*p-notification*/
						$this->session->set_userdata('alert_type','error');
						$this->session->set_userdata('alert_title','Email Verification Failure');
						$this->session->set_userdata('alert_message','Your account has been created successfully... There is something problem to send verification link via mail, please contact to support team !');
						/*p-notification*/
						
						redirect('register/'.$new_admin_id,'refresh'); //$this->load->view('register', $data);
					}
				}
				else
				{
					/*p-notification*/
					$this->session->set_userdata('alert_type','info');
					$this->session->set_userdata('alert_title','Updated Successfully !');
					$this->session->set_userdata('alert_message','Your admin account has beed updated successfully. <br>
					Your account appears to have exhibited automated behaviour that violats the rules.');
					/*p-notification*/

					redirect('register/'.$new_admin_id,'refresh'); //$this->load->view('register', $data);
				}
			}
			else
			{
				$post_data['error'] = 'verification-mail-fail';
				$post_data['message'] = 'Email is invalid, please verify your mail !';
				/*p-notification*/
				$this->session->set_userdata('alert_type','error');
				$this->session->set_userdata('alert_title','Email Verification Failure');
				$this->session->set_userdata('alert_message','Email is invalid, please verify your mail !');
				/*p-notification*/
				
				redirect('register/'.$tbl_admin_id,'refresh'); //$this->load->view('register', $data);
			}
		}	
		else
		{
			redirect('register','refresh');
		}
	}

	public function verify()
	{
		$data['error'] = 'Verification Mail Sent';
		$data['message'] = '<br><br>Your admin account has beed created successfully and the verification mail has been sent on your registered mail. <br>
			Your account appears to have exhibited automated behaviour that violats the rules. <br><br>To unlock your account, please click the link sent on verification mail and confirm that you are valid account owner.';

		$this->load->view('verify', $data);
	}

	public function randomPassword() {
	    $alphabet = '@#$abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890';
	    $pass = array(); //remember to declare $pass as an array
	    $alphaLength = strlen($alphabet) - 1; //put the length -1 in cache
	    for ($i = 0; $i < 8; $i++) {
	        $n = rand(0, $alphaLength);
	        $pass[] = $alphabet[$n];
	    }
	    return implode($pass); //turn the array into a string
	}


    public function edit_admin_info()
    {
        $data['edit_admin_info'] = $this->RegisterModel->edit_admin_info($this->uri->segment(2));
        $data['profile_content'] = $this->RegisterModel->profile_content1($this->uri->segment(2));
        if(isset($data['profile_content'][0]) && !empty($data['profile_content'][0]))
        {
	        $profile_data = $data['profile_content'][0];
			$data['profile_percentage'] = round(count(array_filter($profile_data)) / (count($profile_data)-1) * 100);
			$this->session->set_userdata('profile_percentage',$data['profile_percentage']);
        }
		$data['admin_content'] = $this->RegisterModel->admin_content();
        
        $this->load->view('register',$data);
    }

	public function send_verification($admin_email, $admin_name, $admin_id, $random_verification_key)
	{
		$message = '';
		$message .='<p>Hello '.ucwords($admin_name).',</p>'."\r\n";						

		$message .='<p>The email was generated as a request from the Verify Account retrieval based on the search criteria provided. The login information has only been sent to this email address.</p>'."\r\n";
		$message .='<p>To ensure account security, please change your password immediately through you Account profile.</p>'."\r\n";
		$message .='<p>Your account has been locked or not verified. Your account appears to have exhibited automated behaviour that violats the rules. To unlock your account, please click the below verification link and confirm that you are valid account owner.</p>'."\r\n";
		$message .='<p><a href="'.base_url().'login/verify-admin/'.$admin_id.'/'.$random_verification_key.'">verify your account</a></p>'."\r\n";
		$message .='<p>If this information dose not allow you to access your site(s), please return to the login assistance page and enter a different login name or email address to locate other accounts.</p>'."\r\n";

		//$message .='-----'."\r\n";
		//$message .='<p>If you have any questions or trouble on please contact us at <a href="www.demo.com">www.demo.com</a><br/>'."\r\n";
		//$message .='Website : http://www.demo.com/ <br/> Contact : 1-844-358-1023 <br/> Email : info@demo.com <br/><br/> Thank You! <br/><b> surecashback support services</b> <br/>';
		//$message .= '<a href="'.base_url().'"><img style="width:30%" src="'.base_url().'frontcss/images/logo-blue.png" alt=""></a>';
		//$message .='<hr/><i>* The location is approximate and determined by the IP address it was coming from.</i>'."\r\nThis email can't receive replies.";
		//$message .=''."\r\n"; 

		$result = $this->AdminModel->send_mail('works@oystertechnology.in',$admin_email,'','','domain','Admin account verification',$message);
		if($result)
			return true;
		else
			return false;
	}
	
	public function send_welcome($admin_email, $admin_name)
	{
		$message = '';
		$message .='<p>Welcome '.ucwords($admin_name).',</p>'."\r\n";						

		$message .='<p>Welcome to the wonderful world of domain.com. With advanced features of activating account and new login widgets, you will definitely have a great experience of using My Domain.</p>'."\r\n";
		$message .='<p><b>You received this mail because you registered to the website or modified your registered email or contact number.</b></p>'."\r\n";
		$message .='<p>Thank you for initiating your registration.</p>'."\r\n";
		
		//$message .='-----'."\r\n";
		//$message .='<p>If you have any questions or trouble on please contact us at <a href="www.demo.com">www.demo.com</a><br/>'."\r\n";
		//$message .='Website : http://www.demo.com/ <br/> Contact : 1-844-358-1023 <br/> Email : info@demo.com <br/><br/> Thank You! <br/><b> surecashback support services</b> <br/>';
		//$message .= '<a href="'.base_url().'"><img style="width:30%" src="'.base_url().'frontcss/images/logo-blue.png" alt=""></a>';
		//$message .='<hr/><i>* The location is approximate and determined by the IP address it was coming from.</i>'."\r\nThis email can't receive replies.";
		//$message .=''."\r\n"; 

		$result = $this->AdminModel->send_mail('works@oystertechnology.in',$admin_email,'','','domain','Admin welcome to domain.com',$message);
		//echo $result; die;
		if($result)
			return true;
		else
			return false;
	}
}
?>