<?php
ob_start();
defined('BASEPATH') or die('No direct script access allowed');

class ReportController extends CI_Controller
{
	function __construct()
	{
		parent::__construct();
		$this->load->model('ReportModel');
		if($this->session->userdata('lock_admin_id'))
			redirect('lock','refresh');
		else if(!$this->session->userdata('admin_id'))
			redirect('login','refresh');
	}

	public function index()
	{
		/* content to be display in list view */
		/* content for first section */
		$data['report_summary_user_content'] = $this->ReportModel->report_summary_user_content();
		$data['report_summary_sales_content'] = $this->ReportModel->report_summary_sales_content();
		$data['report_summary_order_content'] = $this->ReportModel->report_summary_order_content();

		/* content for third section */
		$data['report_top_purchase_content'] = $this->ReportModel->report_top_purchase_content();
		$data['report_top_user_content'] = $this->ReportModel->report_top_user_content();
		
		/* search input dropdown content */
		$data['report_product_name_content'] = $this->ReportModel->content(array('tbl_product.product_name'));
		
		$post_data = $this->input->post();
		if(isset($post_data) && !empty($post_data))
		{
			$data['where_or'] = array();
			$data['where'] = '';

			/* select columns list */
			$data['select'] = (!empty($post_data['report_by']) ? $post_data['report_by'] : '*');
			
			/* where columns list with valuew */
			foreach($post_data as $key => $value)
			{
				if(!empty($key) && !empty($value) && $key != 'from_date' && $key != 'to_date' && $key != 'report_by')
					array_push($data['where_or'], $key.' = "'.$value.'"');
			}

			/* where columns - report between from and to date */
			if(isset($post_data['from_date']) && isset($post_data['to_date']) && !empty($post_data['from_date']) && !empty($post_data['to_date']))
			{
				$data['where'] .= '( tbl_order.order_created >= "'.date_format(date_create($post_data['from_date']), "Y-m-d H:i:s").'" and tbl_order.order_created <= "'.date_format(date_create($post_data['to_date']), "Y-m-d H:i:s").'" )';
			}

			/* mearge all the where conditions */
			if(!empty($data['where_or']))
			{
				if(!empty($data['where']))
					$data['where'] .= ' and ( '.implode(' or ', $data['where_or']).' )';
				else
					$data['where'] .= ' ( '.implode(' or ', $data['where_or']).' )';
			}

			/* to get the report result */
			$data['report_result_content'] = $this->ReportModel->report_search_result($data);
			if(!empty($data['report_result_content']))
			{
				$this->session->set_userdata('alert_type','info');
				$this->session->set_userdata('alert_title','Result Found !');
				$this->session->set_userdata('alert_message','The report result has been loaded successfully. Now it is ready to use.');
			}
			else
			{
				$this->session->set_userdata('alert_type','danger');
				$this->session->set_userdata('alert_title','Not Found !');
				$this->session->set_userdata('alert_message','The report result is empty. Please try again with different seach inputs.');
			}
			/* edited record content */
		}
		
		$this->load->view('report', $data);
	}
}
?>