<?php
class CommentModel extends CI_Model
{
	function __construct()
	{
		$this->load->database();
		$this->load->model('AdminModel');
	}

	public function content($columns = null)
	{
		$select = !empty($columns) ? $columns : array('tbl_comment.*','tbl_blog.blog_title as blog_name');
		$table = 'tbl_comment';
		$order_by = 'tbl_comment.tbl_comment_id desc';
		$group_by = !empty($columns) ? $columns : 'tbl_comment.tbl_comment_id';
		$where = $where_or = $where_in = $joins = array(); 
		$joins = array( 
			'tbl_blog | tbl_blog.tbl_blog_id = tbl_comment.comment_blog_id | inner '
		);
		/* optional - $columns is used some times only - when we want single column record without duplication that time it requires */
		return $this->AdminModel->op_mysql_select($select, $table, $where, $where_or, $where_in, $joins, $order_by, $group_by);
	}
	
	public function publish_unpublish_count($status)
	{
		$select = array('count(tbl_comment.tbl_comment_id) as count');
		$table = 'tbl_comment';
		$where = array(
			'tbl_comment.status' => $status
			);
		
		return $this->AdminModel->op_mysql_select($select, $table, $where)[0]['count'];
	}

    public function last_created_updated()
    {
      $select = array('max(tbl_comment.created_date) as created_date, max(tbl_comment.updated_date) as updated_date');
      $table = 'tbl_comment';
      $where = array(
        'tbl_comment.status' => 1
        );
      
      return $this->AdminModel->op_mysql_select($select, $table, $where)[0];
    }

	public function edit($id)
	{
		$select = array('tbl_comment.*');
		$table = 'tbl_comment';
		$where = array(
			'tbl_comment.tbl_comment_id' => $id/*, 
			 'tbl_comment.status' => '1' */
			);
		$order_by = 'tbl_comment.tbl_comment_id desc';
		$group_by = 'tbl_comment.tbl_comment_id';
		$where_or = $joins = $where_in = null;

		return $this->AdminModel->op_mysql_select($select, $table, $where, $where_or, $where_in, $joins, $order_by, $group_by);
	}

	public function post($post_data)
	{
		extract($post_data);
		if(isset($tbl_comment_id) && !empty($tbl_comment_id))
		{
			$table = 'tbl_comment';
			$data = array(  
				'tbl_comment.enquiry_name' => $enquiry_name, 
				'tbl_comment.enquiry_email' => $enquiry_email, 
				'tbl_comment.enquiry_message' => $enquiry_message 
				);
			$where = array(
				'tbl_comment.tbl_comment_id' => $tbl_comment_id
				);

			$this->AdminModel->op_mysql_update($table, $data, $where);
			return 'updated';
		}
		else
		{
			$table = 'tbl_comment';
			$data = array(  
				'tbl_comment.enquiry_name' => $enquiry_name, 
				'tbl_comment.enquiry_email' => $enquiry_email, 
				'tbl_comment.enquiry_message' => $enquiry_message 
				);
				
			if($this->AdminModel->op_mysql_insert($table, $data))
				return 'inserted';
		}
	}
	
  
}
?>