<?php
class LoginModel extends CI_Model
{
	public function __construct()
	{
		$this->load->database();
	}

	public function login_content($username, $password = "")
	{
		$this->db->select("tbl_admin.*, tbl_admin_permission.tbl_admin_permission_id, tbl_admin_permission.admin_permission_name, tbl_admin_permission.admin_permission_access");
		$this->db->from("tbl_admin");
		if(isset($password) && !empty($password))
		$this->db->group_start()->where('tbl_admin.admin_email', $username)->or_group_start()->where('tbl_admin.admin_contact', $username)->group_end()->group_end()->where('tbl_admin.admin_password', $password);

		$this->db->join('tbl_admin_permission', 'tbl_admin.tbl_admin_id = tbl_admin_permission.tbl_admin_id', 'left');
		
		$query = $this->db->get();
        
        return $query->result_array();
	}
	
	public function set_verification_key($admin_id, $admin_key, $admin_verification_status)
	{
		$this->db->set('tbl_admin.admin_key', $admin_key);
		$this->db->set('tbl_admin.admin_verification_status' , $admin_verification_status);
		$this->db->where('tbl_admin.tbl_admin_id', $admin_id);
		$this->db->update('tbl_admin');

		return $this->db->affected_rows();	
	}

	public function reset_password($admin_id, $random_password)
	{
		$this->db->set('tbl_admin.admin_password', $random_password);
		$this->db->where('tbl_admin.tbl_admin_id', $admin_id);
		$this->db->update('tbl_admin');

		return $this->db->affected_rows();	
	}

	public function update_login($username, $login_count='')
	{
		if($login_count)
		{
			$this->db->select("tbl_admin.admin_login_count");
			$this->db->from("tbl_admin");
			$this->db->where("tbl_admin.admin_email",$username);
			$this->db->or_where("tbl_admin.admin_contact",$username);
			$query = $this->db->get();
	        $result = $query->result_array();
	        if(isset($result) && !empty($result))
	        {
		        $count = $result[0]['admin_login_count'];
		        $login_count = $count + 1;
		      	if($login_count > 4)
		        {
		        	$login_count = 5;
		        	$this->db->set('tbl_admin.admin_verification_status', 0);	
		        }
		        $this->db->set('tbl_admin.admin_login_count', $login_count);
	    	}
	 	}
    	else
			$this->db->set('tbl_admin.admin_login_count', $login_count);
		
		$this->db->set('tbl_admin.admin_last_login',  'NOW()', FALSE);
		$this->db->where('tbl_admin.admin_email', $username);
		$this->db->or_where('tbl_admin.admin_contact', $username);		
		$this->db->update('tbl_admin');

		return $login_count;	
	}	

	public function verify_admin($admin_id, $admin_key)
	{
		$this->db->select("tbl_admin.*");
		$this->db->from("tbl_admin");
		$this->db->where("tbl_admin.tbl_admin_id", $admin_id);
		$this->db->where("tbl_admin.admin_key", $admin_key);
		$query = $this->db->get();
        
        return $query->result_array();
	}
}?>