<?php
class ServiceModel extends CI_Model
{
	function __construct()
	{
		$this->load->database();
		$this->load->model('AdminModel');
	}

	public function content($columns = null)
	{
		$select = !empty($columns) ? $columns : array('tbl_service.*');
		$table = 'tbl_service';
		$order_by = 'tbl_service.tbl_service_id desc';
		$group_by = !empty($columns) ? $columns : 'tbl_service.tbl_service_id';
		$where = $where_or = $where_in = $joins = array(); 
		/* optional - $columns is used some times only - when we want single column record without duplication that time it requires */
		return $this->AdminModel->op_mysql_select($select, $table, $where, $where_or, $where_in, $joins, $order_by, $group_by);
	}
	
	public function publish_unpublish_count($status)
	{
		$select = array('count(tbl_service.tbl_service_id) as count');
		$table = 'tbl_service';
		$where = array(
			'tbl_service.service_status' => $status
			);
		
		return $this->AdminModel->op_mysql_select($select, $table, $where)[0]['count'];
	}

    public function last_created_updated()
    {
      $select = array('max(tbl_service.service_created) as service_created, max(tbl_service.service_updated) as service_updated');
      $table = 'tbl_service';
      $where = array(
        'tbl_service.service_status' => 1
        );
      
      return $this->AdminModel->op_mysql_select($select, $table, $where)[0];
    }

	public function edit($id)
	{
		$select = array('tbl_service.*');
		$table = 'tbl_service';
		$where = array(
			'tbl_service.tbl_service_id' => $id/*, 
			 'tbl_service.service_status' => '1' */
			);
		$order_by = 'tbl_service.tbl_service_id desc';
		$group_by = 'tbl_service.tbl_service_id';
		$where_or = $joins = $where_in = null;

		return $this->AdminModel->op_mysql_select($select, $table, $where, $where_or, $where_in, $joins, $order_by, $group_by);
	}

	public function post($post_data)
	{
		extract($post_data);
		if(isset($tbl_service_id) && !empty($tbl_service_id))
		{
			$table = 'tbl_service';
			$data = array(  
				'tbl_service.service_title' => $service_title, 
				'tbl_service.service_home_image' => $service_home_image,
					'tbl_service.service_banner_image' => $service_banner_image,
					'tbl_service.service_page_image' => $service_page_image,
				'tbl_service.service_icon' => $service_icon,
				'tbl_service.service_image1' => $service_image1, 
				'tbl_service.service_image2' => $service_image2, 
				'tbl_service.service_description' => $service_description 
				);
			$where = array(
				'tbl_service.tbl_service_id' => $tbl_service_id
				);

			$this->AdminModel->op_mysql_update($table, $data, $where);
			return 'updated';
		}
		else
		{
			$table = 'tbl_service';
			$data = array(  
				'tbl_service.service_title' => $service_title, 
				'tbl_service.service_home_image' => $service_home_image,
					'tbl_service.service_banner_image' => $service_banner_image,
					'tbl_service.service_page_image' => $service_page_image,
				'tbl_service.service_icon' => $service_icon,
				'tbl_service.service_image1' => $service_image1, 
				'tbl_service.service_image2' => $service_image2, 
				'tbl_service.service_description' => $service_description 
				);
				
			if($this->AdminModel->op_mysql_insert($table, $data))
				return 'inserted';
		}
	}
	
  
}
?>